sub main()
    print "Starting Family Photos"

    m.imageSizeX = 1280
    m.imageSizeY = 720
    m.index = 0

    port = CreateObject("roMessagePort")
    m.screen = CreateObject("roScreen", true)
    m.screen.SetAlphaEnable(true)
    m.screen.Clear(&h000000FF) 
    m.screen.SetMessagePort(port)

    m.arrayImages = [ 
        "pkg:/images/Slide01.jpg", "pkg:/images/Slide02.jpg", "pkg:/images/Slide03.jpg"
    ]

    m.slideCount = m.arrayImages.Count()

    m.currentBitmap = CreateObject("roBitmap", m.arrayImages[m.index])
    m.currentBitmap.SetAlphaEnable(true)

    m.scaleX = m.screen.GetWidth() / m.imageSizeX
    m.scaleY = m.screen.GetHeight() / m.imageSizeY
    m.screen.DrawScaledObject(0, 0, m.scaleX, m.scaleY, m.currentBitmap)

    change_slide()

    while(true)

        msg = wait(0, port) 
        if type(msg) = "roUniversalControlEvent"
            button = msg.GetInt()

            if ((button = 5) Or (button = 6)) and m.index < m.slideCount - 1
                print "Show Next Slide"
                m.index = m.index + 1
                change_slide()
            else if (button = 4) And (m.index > 0)
                print "Show Previous Slide"
                m.index = m.index - 1
                change_slide()
            else if (button = 10)  ' Info button
                display_dialog()
                ' TODO: Fix a bug where the dialog doesn't go away
                m.screen.DrawScaledObject(0, 0, m.scaleX, m.scaleY, m.currentBitmap)
            end if
        end if

    end while

end sub


function display_dialog()

    ' First, create an roImageCanvas to live behind the dialog
    canvas = CreateObject("roImageCanvas")
    message_port = CreateObject("roMessagePort")
    canvas.SetMessagePort(message_port)
    canvas.SetLayer(0, {Color:"#00000000", CompositionMode:"Source_Over"})  ' Transparent
    canvas.Show()

    dialog = CreateObject("roPinEntryDialog")
    dialog.SetMessagePort(message_port)
    dialog.EnableOverlay(true)
    dialog.EnableBackButton(true)
    dialog.SetNumPinEntryFields(4)
    dialog.SetTitle("Enter your Roku PIN to begin your free trial.")
    dialog.AddButton(1, "Continue")
    dialog.AddButton(99, "Back")
    dialog.Show()
    while True
        msg = wait(0, dialog.GetMessagePort())
        if msg <> invalid and type(msg) = "roPinEntryDialogEvent"
            print "msg is "; msg
            if msg.isScreenClosed()
                print "msg is isScreenClosed"; msg; type(msg)
                exit while
            else if msg.isButtonPressed()
                print "the index of the button pressed is"; msg.GetIndex()
                if msg.GetIndex() = 1
                    print "The user entered PIN "; dialog.Pin()
                    dialog.Close()
                else if msg.GetIndex() = 99
                    print "The user cancelled."
                    dialog.Close()
                endif
            end if
        end if
    end while
    canvas.Close()
    print "After closing the dialog and canvas."
    
end function


function change_slide()

    if m.index < 0
        m.nextBitmap = CreateObject("roBitmap", "pkg:/images/background.jpg")
    else if m.index >= m.slideCount
        m.nextBitmap = CreateObject("roBitmap", "pkg:/images/background.jpg")
    else
        m.nextBitmap = CreateObject("roBitmap", m.arrayImages[m.index])
    end if

    m.nextBitmap.SetAlphaEnable(true)

    for i = 0 to 255 step 5
        hexcolor = &hFFFFFFFF - i
        hexcolor2  = &hFFFFFF00 + i

        m.screen.DrawScaledObject(0, 0, m.scaleX, m.scaleY, m.currentBitmap, hexcolor) 'fadeout
        m.screen.DrawScaledObject(0, 0, m.scaleX, m.scaleY, m.nextBitmap, hexcolor2) 'fadein

        m.screen.SwapBuffers()
    end for

    m.currentBitmap = m.nextBitmap 'assign the new next bitmap

end function

